searchData={"items":[{"type":"module","title":"Makeup.Lexers.RustLexer","doc":"Documentation for `MakeupRust`.","ref":"Makeup.Lexers.RustLexer.html"},{"type":"function","title":"Makeup.Lexers.RustLexer.root/2","doc":"Parses the given `binary` as root.\n\nReturns `{:ok, [token], rest, context, position, byte_offset}` or\n`{:error, reason, rest, context, line, byte_offset}` where `position`\ndescribes the location of the root (start position) as `{line, offset_to_start_of_line}`.\n\nTo column where the error occurred can be inferred from `byte_offset - offset_to_start_of_line`.","ref":"Makeup.Lexers.RustLexer.html#root/2"},{"type":"function","title":"Options - Makeup.Lexers.RustLexer.root/2","doc":"* `:byte_offset` - the byte offset for the whole binary, defaults to 0\n  * `:line` - the line and the byte offset into that line, defaults to `{1, byte_offset}`\n  * `:context` - the initial context value. It will be converted to a map","ref":"Makeup.Lexers.RustLexer.html#root/2-options"},{"type":"function","title":"Makeup.Lexers.RustLexer.root_element/2","doc":"Parses the given `binary` as root_element.\n\nReturns `{:ok, [token], rest, context, position, byte_offset}` or\n`{:error, reason, rest, context, line, byte_offset}` where `position`\ndescribes the location of the root_element (start position) as `{line, offset_to_start_of_line}`.\n\nTo column where the error occurred can be inferred from `byte_offset - offset_to_start_of_line`.","ref":"Makeup.Lexers.RustLexer.html#root_element/2"},{"type":"function","title":"Options - Makeup.Lexers.RustLexer.root_element/2","doc":"* `:byte_offset` - the byte offset for the whole binary, defaults to 0\n  * `:line` - the line and the byte offset into that line, defaults to `{1, byte_offset}`\n  * `:context` - the initial context value. It will be converted to a map","ref":"Makeup.Lexers.RustLexer.html#root_element/2-options"},{"type":"module","title":"Makeup.Lexers.RustLexer.Helper","doc":"Helper functions to easily deal with Rust tokens","ref":"Makeup.Lexers.RustLexer.Helper.html"},{"type":"function","title":"Makeup.Lexers.RustLexer.Helper.prepend/2","doc":"","ref":"Makeup.Lexers.RustLexer.Helper.html#prepend/2"},{"type":"function","title":"Makeup.Lexers.RustLexer.Helper.with_optional_separator/2","doc":"","ref":"Makeup.Lexers.RustLexer.Helper.html#with_optional_separator/2"},{"type":"extras","title":"MakeupRust","doc":"# MakeupRust\n\nA [Makeup](https://github.com/elixir-makeup/makeup/) lexer for the Rust language.","ref":"readme.html"},{"type":"extras","title":"Installation - MakeupRust","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `makeup_rust` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:makeup_rust, \"~> 0.3.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Example - MakeupRust","doc":"Following an highlighted example taken from [`rhai_rustler`](https://github.com/fabriziosestito/rhai_rustler): \n\n```rust\nmod errors;\nmod types;\n\nuse std::collections::HashMap;\n\nuse rhai::{Dynamic, Engine, Scope};\nuse rustler::{Env, Term};\n\n#[rustler::nif]\nfn eval<'a>(\n    env: Env<'a>,\n    expression: &str,\n    expression_scope: HashMap >,\n) -> Result , Term<'a>> {\n    // Create an 'Engine'\n    let mut engine = Engine::new();\n    engine.set_fail_on_invalid_map_property(true);\n    let engine = engine;\n\n    let mut scope = Scope::new();\n\n    // Add variables to the scope\n    for (k, v) in &expression_scope {\n        scope.push_dynamic(k, types::to_dynamic(env, v));\n    }\n\n    match engine.eval_with_scope:: (&mut scope, expression) {\n        Ok(result) => Ok(types::from_dynamic(env, result)),\n\n        Err(e) => Err(errors::to_error(env, *e)),\n    }\n}\n\nrustler::init!(\"Elixir.Rhai.Native\", [eval]);\n```","ref":"readme.html#example"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}